<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import type { BucketOut } from "@/client/types.gen";
import dayjs from "dayjs";
import { filesize } from "filesize";
import { useS3ObjectStore } from "@/stores/s3objects";
import { computed } from "vue";
import { environment } from "@/environment";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import BucketLimitProgressBar from "@/components/object-storage/BucketLimitProgressBar.vue";
import CreateOtrModal from "@/components/modals/CreateOtrModal.vue";
import { useUserStore } from "@/stores/users";
import ShowOtrModal from "@/components/modals/ShowOtrModal.vue";
import { useOTRStore } from "@/stores/otrs";

const props = defineProps<{
  modalId: string;
  bucket: BucketOut;
}>();

const objectRepository = useS3ObjectStore();
const userRepository = useUserStore();
const otrRepository = useOTRStore();

const bucketMeta = computed<[number, number]>(() =>
  objectRepository.getMeta(props.bucket.name),
);
const publicHttpLink = computed<string>(
  () => environment.S3_URL + "/" + props.bucket.name,
);
const s3Link = computed<string>(() => "s3://" + props.bucket.name);
</script>

<template>
  <show-otr-modal
    :otr-target-id="bucket.name"
    modal-id="show-bucket-otr-modal-from-details"
    :back-modal-id="props.modalId"
  />
  <create-otr-modal
    modal-id="create-bucket-otr-modal"
    :target="bucket"
    :back-modal-id="props.modalId"
  />
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="false"
    modal-label="Bucket Detail Modal"
    size-modifier-modal="lg"
  >
    <template #header>
      <h4>
        Bucket Details <i>{{ props.bucket.name }}</i>
      </h4>
    </template>

    <template #body>
      <div class="container-fluid">
        <table class="table table-sm table-borderless">
          <tbody>
            <tr>
              <th scope="row" class="col-3">Name</th>
              <td class="col-9">{{ props.bucket.name }}</td>
            </tr>
            <tr>
              <th scope="row">Creation date</th>
              <td>
                {{
                  dayjs
                    .unix(props.bucket.created_at)
                    .format("YYYY-MM-DD HH:mm:ss")
                }}
              </td>
            </tr>
            <tr>
              <th scope="row">Objects</th>
              <td>
                {{ bucketMeta[0]
                }}<span v-if="bucket.object_limit"
                  >/{{ bucket.object_limit }}</span
                >
                <bucket-limit-progress-bar
                  v-if="bucket.object_limit"
                  :maximum="bucket.object_limit"
                  :current-val="bucketMeta[0]"
                />
              </td>
            </tr>
            <tr>
              <th scope="row">Size</th>
              <td>
                {{ filesize(bucketMeta[1])
                }}<span v-if="bucket.size_limit"
                  >/{{ filesize(1024 * bucket.size_limit) }}</span
                >
                <bucket-limit-progress-bar
                  v-if="bucket.size_limit"
                  :maximum="1024 * bucket.size_limit"
                  :current-val="bucketMeta[1]"
                />
              </td>
            </tr>
            <tr>
              <th scope="row">Description</th>
              <td class="text-break">{{ props.bucket.description }}</td>
            </tr>
            <tr v-if="bucket.public">
              <th scope="row">Public HTTP link</th>
              <td>
                <a :href="publicHttpLink" target="_blank"
                  >{{ publicHttpLink }}
                  <font-awesome-icon
                    icon="fa-solid fa-arrow-up-right-from-square"
                    class="ms-1"
                  />
                </a>
              </td>
            </tr>
            <tr>
              <th scope="row">S3 link</th>
              <td>
                {{ s3Link }}
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </template>
    <template #footer>
      <button
        v-if="otrRepository.otrMapping[bucket.name]"
        type="button"
        class="btn btn-primary"
        data-bs-target="#show-bucket-otr-modal-from-details"
        data-bs-toggle="modal"
      >
        Show transfer request
      </button>
      <button
        v-if="
          bucket.owner_id === userRepository.currentUID &&
          otrRepository.otrMapping[bucket.name] == undefined
        "
        type="button"
        class="btn btn-primary"
        data-bs-target="#create-bucket-otr-modal"
        data-bs-toggle="modal"
      >
        Transfer ownership
      </button>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped>
th {
  font-weight: bold;
  text-align: end;
}
</style>
